From cad3fbd00eeea4488a5155c1a5004e363a1ad4e4 Mon Sep 17 00:00:00 2001 From: "huangge1199@hotmail.com" Date: Mon, 12 Jul 2021 23:50:00 +0800 Subject: [PATCH] =?UTF-8?q?733:=E5=9B=BE=E5=83=8F=E6=B8=B2=E6=9F=93?= MIME-Version: 1.0 Content-Type: text/plain; charset=UTF-8 Content-Transfer-Encoding: 8bit --- .../java/leetcode/editor/cn/FloodFill.java | 67 +++++++++++++++++++ src/main/java/leetcode/editor/cn/FloodFill.md | 30 +++++++++ 2 files changed, 97 insertions(+) create mode 100644 src/main/java/leetcode/editor/cn/FloodFill.java create mode 100644 src/main/java/leetcode/editor/cn/FloodFill.md diff --git a/src/main/java/leetcode/editor/cn/FloodFill.java b/src/main/java/leetcode/editor/cn/FloodFill.java new file mode 100644 index 0000000..e3ad54d --- /dev/null +++ b/src/main/java/leetcode/editor/cn/FloodFill.java @@ -0,0 +1,67 @@ +//有一幅以二维整数数组表示的图画,每一个整数表示该图画的像素值大小,数值在 0 到 65535 之间。 +// +// 给你一个坐标 (sr, sc) 表示图像渲染开始的像素值(行 ,列)和一个新的颜色值 newColor,让你重新上色这幅图像。 +// +// 为了完成上色工作,从初始坐标开始,记录初始坐标的上下左右四个方向上像素值与初始坐标相同的相连像素点,接着再记录这四个方向上符合条件的像素点与他们对应四个方 +//向上像素值与初始坐标相同的相连像素点,……,重复该过程。将所有有记录的像素点的颜色值改为新的颜色值。 +// +// 最后返回经过上色渲染后的图像。 +// +// 示例 1: +// +// +//输入: +//image = [[1,1,1],[1,1,0],[1,0,1]] +//sr = 1, sc = 1, newColor = 2 +//输出: [[2,2,2],[2,2,0],[2,0,1]] +//解析: +//在图像的正中间,(坐标(sr,sc)=(1,1)), +//在路径上所有符合条件的像素点的颜色都被更改成2。 +//注意,右下角的像素没有更改为2, +//因为它不是在上下左右四个方向上与初始点相连的像素点。 +// +// +// 注意: +// +// +// image 和 image[0] 的长度在范围 [1, 50] 内。 +// 给出的初始点将满足 0 <= sr < image.length 和 0 <= sc < image[0].length。 +// image[i][j] 和 newColor 表示的颜色值在范围 [0, 65535]内。 +// +// Related Topics 深度优先搜索 广度优先搜索 数组 矩阵 +// 👍 195 👎 0 + +package leetcode.editor.cn; + +//733:图像渲染 +class FloodFill { + public static void main(String[] args) { + //测试代码 + Solution solution = new FloodFill().new Solution(); + } + + //力扣代码 + //leetcode submit region begin(Prohibit modification and deletion) + class Solution { + public int[][] floodFill(int[][] image, int sr, int sc, int newColor) { + if (newColor == image[sr][sc]) { + return image; + } + dfs(image, sr, sc, newColor, image[sr][sc]); + return image; + } + + private void dfs(int[][] image, int sr, int sc, int newColor, int oldColor) { + if (sr < 0 || sr >= image.length || sc < 0 || sc >= image[0].length || image[sr][sc] != oldColor) { + return; + } + image[sr][sc] = newColor; + dfs(image, sr - 1, sc, newColor, oldColor); + dfs(image, sr + 1, sc, newColor, oldColor); + dfs(image, sr, sc - 1, newColor, oldColor); + dfs(image, sr, sc + 1, newColor, oldColor); + } + } +//leetcode submit region end(Prohibit modification and deletion) + +} \ No newline at end of file diff --git a/src/main/java/leetcode/editor/cn/FloodFill.md b/src/main/java/leetcode/editor/cn/FloodFill.md new file mode 100644 index 0000000..cff9080 --- /dev/null +++ b/src/main/java/leetcode/editor/cn/FloodFill.md @@ -0,0 +1,30 @@ +

有一幅以二维整数数组表示的图画,每一个整数表示该图画的像素值大小,数值在 0 到 65535 之间。

+ +

给你一个坐标 (sr, sc) 表示图像渲染开始的像素值(行 ,列)和一个新的颜色值 newColor,让你重新上色这幅图像。

+ +

为了完成上色工作,从初始坐标开始,记录初始坐标的上下左右四个方向上像素值与初始坐标相同的相连像素点,接着再记录这四个方向上符合条件的像素点与他们对应四个方向上像素值与初始坐标相同的相连像素点,……,重复该过程。将所有有记录的像素点的颜色值改为新的颜色值。

+ +

最后返回经过上色渲染后的图像。

+ +

示例 1:

+ +
+输入: 
+image = [[1,1,1],[1,1,0],[1,0,1]]
+sr = 1, sc = 1, newColor = 2
+输出: [[2,2,2],[2,2,0],[2,0,1]]
+解析: 
+在图像的正中间,(坐标(sr,sc)=(1,1)),
+在路径上所有符合条件的像素点的颜色都被更改成2。
+注意,右下角的像素没有更改为2,
+因为它不是在上下左右四个方向上与初始点相连的像素点。
+
+ +

注意:

+ + +
Related Topics
  • 深度优先搜索
  • 广度优先搜索
  • 数组
  • 矩阵
  • \n
  • 👍 195
  • 👎 0
  • \ No newline at end of file